\ Synchronization
REQUIRE ?UM/MOD ~nn/lib/UMMOD.f
REQUIRE azAVL ~nn/lib/utils/avlaz.f

azAVL POINTER file-list

: TIME-DIFF ( a u -- -1/0/1 )
    fattr ROT ROT FILE-ATTRIBUTES 0= IF 1313 RES 3 bkLOG -1 EXIT THEN
\    __FFB ftCreationTime fattr ftCreationTime COMPARE-FILE-TIME 0<
    (TIME-1)  (TIME-2)  COMPARE-FILE-TIME DUP 0= toCompareCreationTime @ AND
    IF DROP (TIME-1C) (TIME-2C) COMPARE-FILE-TIME THEN
    DUP IF 1310 RES 3 bkLOG THEN
\    OR
;

: OLD? ( a u -- ? ) TIME-DIFF 0< ;

: TIME<> ( a u -- ? ) TIME-DIFF 0<> ;


0 [IF]
: ANY-DIFF? { a u -- ? }
    fattr a u FILE-ATTRIBUTES 0= IF TRUE EXIT THEN
\    __FFB ftCreationTime fattr ftCreationTime COMPARE-FILE-TIME 0<
    __FFB ftLastWriteTime fattr ftLastWriteTime COMPARE-FILE-TIME 0<>
    __FFB nFileSizeHigh 2@ fattr nFileSizeHigh 2@ D<> OR
\    OR
;
[THEN]

CREATE <MD5-1> 16 ALLOT
CREATE <MD5-2> 16 ALLOT
: MD5-1 <MD5-1> MD5String ;
: MD5-2 <MD5-2> MD5String ;

: MD5-DIFF? { a u -- ? }
\    ." MD5: " a u TYPE CR
    <MD5-1> FOUND-FULLPATH MD5File THROW
    <MD5-2> a u            MD5File THROW
    <MD5-1> 16 <MD5-2> 16 COMPARE 0<>
    DUP IF 1311 RES 3 bkLOG THEN
;

: ANY-DIFF? { a u -- ? }
    a u TIME<> ?DUP 0=
    IF SIZE-1 SIZE-2 D<>
        DUP
        IF
            1312 RES 3 bkLOG
        ELSE
            md5 @ IF DROP  a u MD5-DIFF? THEN
        THEN
    THEN
;

( Also any difference)
: OLD2?
    ExistingOnly @      IF 2DUP EXIST? 0= IF 2DROP FALSE EXIT THEN THEN
    IgnoreExisting @    IF 2DUP EXIST? IF 2DROP FALSE EXIT THEN THEN

    AnyDifference @
    IF
        ANY-DIFF?
    ELSE
        OLD?
    THEN
;

: ?BACKUP1
    BackupPath @ 0<> NoCopy @ 0= AND
    IF
        dstPATH-p 2DUP EXIST?
        IF backPATH-p COPY ELSE 2DROP THEN
    THEN
;

: ?BACKUP2
    BackupPath @ 0<> NoCopy @ 0= AND
    IF
        srcPATH  2DUP EXIST?
        IF backPATH-p COPY ELSE 2DROP THEN
    THEN
;

: COPY-NEW1 dstPATH-p \ DBG( ." -5-" 2DUP TYPE CR )
       OLD2? IF ?BACKUP1 COPY1 THEN ;
: COPY-NEW2 srcPATH OLD2? IF ?BACKUP2 COPY2 THEN ;

: ABSENT? ( a u -- ?)
\    ." Absent=" 2DUP TYPE
    FILE-EXIST DUP ERROR_FILE_NOT_FOUND = OVER ERROR_PATH_NOT_FOUND = OR IF DROP 0 THEN
    THROW
    0=
\    DUP IF ."  yes" ELSE ."  no" THEN CR
;


: PROPER-DELETE
    Verbose @ IF S" DELETE" FOUND-RELPATH DstFullPath 1 bkLOG2 THEN
    BeforeDelete
    NoCopy @ 0=
    IF
        FOUND-RELPATH DstFullPath
        DELETE-R/O-FILE THROW
    THEN
;

: DEL-ABS
    srcPATH ABSENT?
    IF
        PROPER-DELETE
    THEN ;

: DEL-ABS-DIR
    DelAbsentDir @
    IF
        srcPATH ABSENT?
        IF
            Verbose @ IF S" RMDIR" FOUND-RELPATH DstFullPath 1 bkLOG2 THEN
            BeforeDelete
            NoCopy @ 0=
            IF
                FOUND-RELPATH DstFullPath DEL-TREE THROW
            THEN
        THEN
    THEN ;

: SYNC1 ['] COPY-DIR1 ['] COPY-NEW1 PASS-TREE-SRC ;

: SYNC2 ['] COPY-DIR2 ['] COPY-NEW2 PASS-TREE-DST ;


: DELETE-ABSENT SubTree @ IF ['] DEL-ABS-DIR ELSE ['] NOOP THEN ['] DEL-ABS PASS-TREE-DST ;

: ABSENT-IN-LIST? DROP file-list Find 0= ;

: DEL-ABS-BY-LIST
    FOUND-RELPATH ABSENT-IN-LIST?
    InvertDelAbsent @ IF 0= THEN
    IF
        Verbose @ IF S" DELETE" FOUND-RELPATH DstFullPath 1 bkLOG2 THEN
        BeforeDelete
        NoCopy @ 0=
        IF
            FOUND-RELPATH DstFullPath
            DELETE-R/O-FILE THROW
        THEN
    THEN ;

: DELETE-ABSENT-BY-LIST
    ['] NOOP ['] DEL-ABS-BY-LIST PASS-TREE-1-DST
;


: test-iCNT-p
    iCNT @ 1 > KeepPath @ 0= AND
    SyncWays @ 2 = AND
    1011 ?ERR-LOG
;

: DELETE-IF-NO-FIT PROPER-DELETE ;

: ?DELETE-ABSENT
   DelAbsent @  iCNT @ 1 > IF KeepPath @ 0<> AND THEN
   IF
      1211 RES 1 bkLOG
          DeleteExcluded @
          IF
              PASS-TREE-XT-NO-FIT-DIR OFF
              ['] DELETE-IF-NO-FIT PASS-TREE-XT-NO-FIT !
          THEN
      DELETE-ABSENT
          PASS-TREE-XT-NO-FIT-DIR OFF
          PASS-TREE-XT-NO-FIT OFF
   THEN
;

:NONAME
    test-iCNT-p
[ DEBUG? ] [IF] TIMER-START [THEN]
    Compress OFF ZSuffix OFF
    1207 RES ( S" Start synchronization") 1 bkLOG
    SyncWays @ 1 = DeleteBefore @ 0<> AND IF ?DELETE-ABSENT THEN
    SyncWays @ 2 = IF 1209 ELSE 1214 THEN RES 1 bkLOG
    SYNC1
    SyncWays @ 2 =
    IF
       1210 RES 1 bkLOG
       SYNC2
    ELSE
       DeleteBefore @ 0= IF ?DELETE-ABSENT THEN
    THEN
    1208 RES ( S" Stop synchronization") 1 bkLOG
[ DEBUG? ] [IF] .timer [THEN]
; TO SYNCHRONIZATION

: LoadFList
    azAVL NEW TO file-list
    [NONAME
        [NONAME
            1 PARSE file-list Insert
        NONAME]
        SWAP NodeValue ASCIIZ> INCLUDE-WITH
    NONAME] src-list DoList
;

:NONAME
    test-iCNT-p
[ DEBUG? ] [IF] TIMER-START [THEN]
    Compress OFF ZSuffix OFF
    1207 RES ( S" Start synchronization") 1 bkLOG
    1211 RES 1 bkLOG
    IasList @
    IF
        LoadFList
        DELETE-ABSENT-BY-LIST
    ELSE
        DELETE-ABSENT
    THEN

    1208 RES ( S" Stop synchronization") 1 bkLOG
[ DEBUG? ] [IF] .timer [THEN]
; TO DELETE_ABSENT
