\ VERSIONED_STACK

0 VALUE NumVerDir

: VerDigits ( -- # )
    BkDepth @ 10    < IF 1 ELSE
    BkDepth @ 100   < IF 2 ELSE
    BkDepth @ 1000  < IF 3 ELSE
    BkDepth @ 10000 < IF 4 ELSE 5 THEN THEN THEN THEN
;

: NumVerDirX
    NumVerDir S>D
    <# VerDigits 0 DO # LOOP #> ;

VARIABLE VerDirSuffix
: VerDirSuffix@ VerDirSuffix @ ?DUP IF ASCIIZ> ELSE S" " THEN ;
: DstVerDir  ( ver -- a u)
    TO NumVerDir
    BkDepth @
    IF
        StackDirName @
        IF S" %DstPath%\%NumVerDirX%_%StackDirName @AZ%%VerDirSuffix@%"
        ELSE S" %DstPath%\%NumVerDirX%%VerDirSuffix@%" THEN
        EVAL-SUBST
    ELSE
        DstPath
    THEN
;

VARIABLE VerDirFound

: DstVerDir* ( n -- a u ?)
    TO NumVerDir
    BkDepth @
    IF
        StackDirName @
        IF S" %DstPath%\%NumVerDirX%_*" EVAL-SUBST DROP
            DBG( ." -1- " DUP ASCIIZ> TYPE CR)
            FIND-FIRST-FILE
            IF  \ DUP ASCIIZ> TYPE CR
                VerDirFound !
                S" %DstPath%\%VerDirFound @AZ%" EVAL-SUBST
                DBG( ." -2- " 2DUP TYPE CR)
                TRUE
            ELSE S" " FALSE THEN
            FIND-CLOSE
        ELSE S" %DstPath%\%NumVerDirX%%VerDirSuffix@%" EVAL-SUBST
            DBG( ." -3- " 2DUP TYPE CR)
        TRUE THEN
    ELSE DstPath TRUE THEN
\    >R
\ ." 2:" 2DUP TYPE CR KEY DROP
\    R>
    ;

: fNotFound? ( ? -- ?)
    DUP ERROR_PATH_NOT_FOUND = SWAP ERROR_FILE_NOT_FOUND = OR ;

: RenDir  \ ." Rename: " DUP ASCIIZ> TYPE ." -->" OVER ASCIIZ> TYPE CR KEY DROP
    MoveFileA ERR DUP  fNotFound? IF DROP ELSE THROW THEN ;

USER-CREATE DstVerDir2 2 CELLS USER-ALLOT

: DEL/EMPTY-TREE ( a u -- ior)
    OVER GetFileAttributesA FILE_ATTRIBUTE_DIRECTORY AND
    IF
       BkDepth @ IF DEL-TREE ELSE EMPTY-TREE THEN
    ELSE
       BkDepth @ IF DELETE-FILE ELSE 2DROP 0 THEN
    THEN
;

: BackRen { \ p2 n1 -- }
    1301 RES 3 bkLOG
    BkDepth @ DstVerDir*
    IF 
        DEL/EMPTY-TREE
        ?DUP IF DUP fNotFound? IF DROP ELSE THROW THEN THEN
    ELSE 2DROP THEN
    BkDepth @
    IF
        BkDepth @ 1
        ?DO
            BkDepth @ I - TO n1
            StackDirName @ 0=
            IF
                n1 1+ DstVerDir DROP
                n1 DstVerDir DROP
                RenDir
            ELSE
                n1 DstVerDir*
                IF
\                    2DUP TYPE CR KEY DROP
                    2DUP S>ZALLOC TO p2 DROP
                    n1 1+ S>D <# VerDigits 0 DO # LOOP #>
                    p2 dst-base-len + 1+ SWAP CMOVE
                    p2 SWAP
                    RenDir
                ELSE 2DROP THEN
            THEN
        LOOP
    THEN
;

: OLD3?
    compress? 0= AnyDifference @ 0<> AND
    IF
        ANY-DIFF?
    ELSE
        OLD?
    THEN
;

VARIABLE ver-changed

: ver-test-src
    dstPATH-p
\   DBG( ." -3- " 2DUP TYPE CR)
    OLD3?
    IF
\        S" M %FOUND-RELPATH% %TIME-1% -- %TIME-2%" 3 bkLOG
\        1310 RES 3 bkLOG
        ver-changed ON FF-EXIT
    THEN ;
\ : ver-test-dst dstPATH-p OLD2? IF -1 THROW THEN ;

VARIABLE ver-dst-list

: set-ver-dst-list
    set-1-dst
    1 DstVerDir S>ZALLOC ver-dst-list AddNode
    set-1-dst
;

: VerChanged? ( -- ? )
    dst-list @
    ver-dst-list @ dst-list !
    ver-changed OFF
    ['] NOOP ['] ver-test-src PASS-TREE-SRC
\    ['] NOOP ['] ver-test-dst PASS-TREE-DST
    dst-list ! set-1-dst
    ver-changed @
;

:NONAME { -- }
[ DEBUG? ] [IF] TIMER-START [THEN]
    set-ver-dst-list
    NoCopy @ 0=
    IF
        1 DstVerDir*
        IF \ DBG( ." -4-" 2DUP TYPE CR)
           EXIST?
           IF
              PushChanged @
              IF VerChanged? 0=
                 IF 1204 RES ( S" Nothing backup") 1 bkLOG EXIT THEN
              THEN
              set-1-src
              BackRen
           THEN
        ELSE 2DROP THEN
    THEN
    1202 RES ( S" Start backup") 1 bkLOG

    ver-dst-list @ dst-list !

    MAKE-DIR-SA 0! 1 DstVerDir MAKE-DIRS THROW
    
[ DEBUG? ] [IF] .timer [THEN]
    ['] COPY-DIR1 ['] COPY1 PASS-TREE-SRC
[ DEBUG? ] [IF] .timer [THEN]
    1203 RES ( S" Stop backup") 1 bkLOG
; TO VERSIONED_STACK


:NONAME { -- }
[ DEBUG? ] [IF] TIMER-START [THEN]
    1200 RES ( S" Start copy") 1 bkLOG
[ DEBUG? ] [IF] .timer [THEN]
    ['] COPY-DIR1 ['] COPY1 PASS-TREE-SRC
[ DEBUG? ] [IF] .timer [THEN]
    1201 RES ( S" Stop copy") 1 bkLOG
; TO EXACT_COPY
