; creates nnbackupxxx.exe
;
;--------------------------------

!define VER_MAJOR 2
!define VER_MINOR 28
!define VERSION 228b1
!define PROG_NAME "nnBackup"
!define PROG_SHORT_NAME "nnbackup"
!define COMPILE_DIR "e:\home\SRC\backup2\install\image\data"

; allowing us to use SF_SELECTED constant
!include "Sections.nsh"

LoadLanguageFile "${NSISDIR}\Contrib\Language files\English.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language files\Russian.nlf"
Name "${PROG_NAME} ${VER_MAJOR}.${VER_MINOR}"

; The file to write
OutFile "${PROG_SHORT_NAME}${VERSION}.exe"

; license
LangString ReadLicenseText ${LANG_ENGLISH} "Please, review the license terms before installing ${PROG_NAME}."
LangString ReadLicenseText ${LANG_RUSSIAN} ",         ${PROG_NAME}."
LicenseText $(ReadLicenseText)
LicenseLangString LicenseSource ${LANG_ENGLISH} "${COMPILE_DIR}\..\presetup\license.txt"
LicenseLangString LicenseSource ${LANG_RUSSIAN} "${COMPILE_DIR}\..\presetup\license.rus"
LicenseData $(LicenseSource) 

; The default installation directory
InstallDir "$PROGRAMFILES\${PROG_NAME}\"

; Registry key to check for directory (so if you install again, it will
; overwrite the old one automatically}
InstallDirRegKey HKLM "SOFTWARE\nnSoft\${PROG_NAME}" "path"

; The text to prompt the user to choose components
LangString ChooseComponentsText ${LANG_ENGLISH} "Check the components you want to install and uncheck the components you don't want to install. Click Next to continue."
LangString ChooseComponentsText ${LANG_RUSSIAN} " ,   .$\r$\n   ."
ComponentText $(ChooseComponentsText)

; The text to prompt the user to enter a directory
LangString EnterDirectoryText ${LANG_ENGLISH} "Choose the folder in which to install ${PROG_NAME}.$\r$\nTo install in a different folder, click Browse and select another folder.$\r$\nClick Install to start the installation."
LangString EnterDirectoryText ${LANG_RUSSIAN} " ,     ${PROG_NAME}.$\r$\n  ,    .$\r$\n ,    ."
DirText $(EnterDirectoryText)

; show the "show details" box
ShowInstDetails show
ShowUninstDetails show

; whether or not the file should overwrite any existing files that are present
SetOverwrite on
; setting the default compressor
SetCompressor lzma

;--------------------------------
; LangStrings
;

LangString AbortMessage ${LANG_ENGLISH} "Are you sure you want to quit ${PROG_NAME} ${VER_MAJOR}.${VER_MINOR} Setup?"
LangString AbortMessage ${LANG_RUSSIAN} " ,      ${PROG_NAME} ${VER_MAJOR}.${VER_MINOR}?"
LangString AdministratorMessage ${LANG_ENGLISH} "For installation of ${PROG_NAME} it is necessary to have administrator rights on this computer."
LangString AdministratorMessage ${LANG_RUSSIAN} "  ${PROG_NAME}       ."
LangString Sec1Name ${LANG_ENGLISH} "Program Files (required)"
LangString Sec1Name ${LANG_RUSSIAN} "  ${PROG_NAME}"
LangString Sec2Name ${LANG_ENGLISH} "Documentation"
LangString Sec2Name ${LANG_RUSSIAN} ""
LangString Sec3Name ${LANG_ENGLISH} "Start Menu Shortcuts"
LangString Sec3Name ${LANG_RUSSIAN} "   "
LangString Sec31Name ${LANG_ENGLISH} "For current user only"
LangString Sec31Name ${LANG_RUSSIAN} "   "
LangString Sec32Name ${LANG_ENGLISH} "For all users"
LangString Sec32Name ${LANG_RUSSIAN} "  "
LangString Sec33Name ${LANG_ENGLISH} "Do not create shortcuts"
LangString Sec33Name ${LANG_RUSSIAN} "  "
;LangString Sec4Name ${LANG_ENGLISH} "For all users"
;LangString Sec4Name ${LANG_RUSSIAN} "  "

;--------------------------------
;
; The stuff to install

Section $(Sec1Name) sec1
  ; read-only section
  SectionIn RO

  ; Set output path to the installation directory.
  SetOutPath $INSTDIR

  ; Put file there
  File "${COMPILE_DIR}\*.exe"
  File "${COMPILE_DIR}\*.dll"

  SetOutPath $INSTDIR\res
  File "${COMPILE_DIR}\res\*.txt"

  ; Write the installation path into the registry
  WriteRegStr HKLM "SOFTWARE\nnSoft\${PROG_NAME}" "path" "$INSTDIR"

  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PROG_NAME}" "DisplayName" "${PROG_NAME} (remove only)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PROG_NAME}" "UninstallString" '"$INSTDIR\uninstall.exe"'
SectionEnd

Section $(Sec2Name) sec2
; optional section (can be disabled by the user)
  SetOutPath $INSTDIR\doc
  File "${COMPILE_DIR}\doc\*.chm"
  File "${COMPILE_DIR}\doc\*.txt"
SectionEnd

;Section $(Sec4Name) sec4
; optional section (can be disabled by the user)
    ;RMDir /r "$SMPROGRAMS\${PROG_NAME}"
;    SetShellVarContext all

;SectionEnd

SubSection /e $(Sec3Name) sec3

    Section $(Sec31Name) sec31
        Call createShortCuts
    SectionEnd

    Section $(Sec32Name) sec32
        ; RMDir /r "$SMPROGRAMS\${PROG_NAME}"
        SetShellVarContext all
        Call createShortCuts
    SectionEnd

    Section $(Sec33Name) sec33
    SectionEnd

; optional section (can be disabled by the user)

;  RMDir /r "$SMPROGRAMS\${PROG_NAME}"
;  CreateDirectory "$SMPROGRAMS\${PROG_NAME}"
;  CreateShortCut "$SMPROGRAMS\${PROG_NAME}\Uninstall ${PROG_NAME}.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0

;  SectionGetFlags ${Sec2} $R0
;  IntOp $R0 $R0 & ${SF_SELECTED}
;  StrCmp $R0 ${SF_SELECTED} "" +5
;  CreateShortCut "$SMPROGRAMS\${PROG_NAME}\${PROG_NAME} Readme.lnk" "$INSTDIR\doc\readme.txt" "" "$INSTDIR\doc\readme.txt" 0
;  CreateShortCut "$SMPROGRAMS\${PROG_NAME}\${PROG_NAME} Readme (rus).lnk" "$INSTDIR\doc\readme.rus.txt" "" "$INSTDIR\doc\readme.rus.txt" 0
;  CreateShortCut "$SMPROGRAMS\${PROG_NAME}\${PROG_NAME} Help.lnk" "$INSTDIR\doc\help.chm" "" "$INSTDIR\doc\help.chm" 0
;  CreateShortCut "$SMPROGRAMS\${PROG_NAME}\${PROG_NAME} Help (rus).lnk" "$INSTDIR\doc\help_ru.chm" "" "$INSTDIR\doc\help_ru.chm" 0
SubSectionEnd

Section
; unnamed section - the default one
  WriteUninstaller "uninstall.exe"
SectionEnd

;--------------------------------
;
; Uninstaller

LangString BeforeUninstallText ${LANG_ENGLISH} "This will uninstall ${PROG_NAME} ${VER_MAJOR}.${VER_MINOR} from your computer. Click Uninstall to start the uninstallation."
LangString BeforeUninstallText ${LANG_RUSSIAN} "  ${PROG_NAME} ${VER_MAJOR}.${VER_MINOR}     .      ."
UninstallText $(BeforeUninstallText)

; Uninstall section
Section "Uninstall"

  ; remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PROG_NAME}"
  DeleteRegKey HKLM "SOFTWARE\nnSoft\${PROG_NAME}"
  ; this key will be deleted only if it is empty
  DeleteRegKey /ifempty HKLM "SOFTWARE\nnSoft"

  ; remove files and uninstaller
  Delete $INSTDIR\makensisw.exe
  Delete $INSTDIR\uninstall.exe

  ; remove all the files
  Delete "$INSTDIR\*.exe"
  Delete "$INSTDIR\*.dll"

  ; remove directories used
  RMDir /r "$INSTDIR\doc"
  RMDir /r "$INSTDIR\res"
  RMDir "$INSTDIR"
  SetShellVarContext current
  RMDir /r "$SMPROGRAMS\${PROG_NAME}"
  SetShellVarContext all
  RMDir /r "$SMPROGRAMS\${PROG_NAME}"
SectionEnd

;--------------------------------
; Functions
;

; warning when cancelling installation
Function .onUserAbort
   MessageBox MB_YESNO $(AbortMessage) IDYES NoCancelAbort
     Abort ; causes installer to not quit.
   NoCancelAbort:
FunctionEnd

Function .onInit

    Push $0

    StrCpy $1 ${sec31} ; Gotta remember which section we are at now...
    SectionGetFlags ${sec31} $0
    IntOp $0 $0 | ${SF_SELECTED}
    SectionSetFlags ${sec31} $0
    # !insertmacro SelectSection ${sec1}

    SectionGetFlags ${sec32} $0
    IntOp $0 $0 & ${SECTION_OFF}
    SectionSetFlags ${sec32} $0
    # !insertmacro UnselectSection ${sec2}

    SectionGetFlags ${sec33} $0
    IntOp $0 $0 & ${SECTION_OFF}
    SectionSetFlags ${sec33} $0
    # !insertmacro UnselectSection ${sec3}

    Pop $0

    ; creating language selection dialog
    Call IsSilent
    Pop $0
    StrCmp $0 1 initexit 0
    Push ""
    Push ${LANG_ENGLISH}
    Push English
    Push ${LANG_RUSSIAN}
    Push Russian
    Push A ; A means auto count languages
           ; for the auto count to work the first empty push (Push "") must remain
    LangDLL::LangDialog "Installer Language" "Please select the language of the installer"

    Pop $LANGUAGE
    StrCmp $LANGUAGE "cancel" 0 +2
        Abort
initexit:
FunctionEnd


Function .onSelChange
    Push $0

    Push $2
    StrCpy $2 ${SF_SELECTED}
    SectionGetFlags ${sec31} $0
    IntOp $2 $2 & $0
    SectionGetFlags ${sec32} $0
    IntOp $2 $2 & $0
    SectionGetFlags ${sec33} $0
    IntOp $2 $2 & $0
    StrCmp $2 0 skip
        SectionSetFlags ${sec31} 0
        SectionSetFlags ${sec32} 0
        SectionSetFlags ${sec33} 0
    skip:
    Pop $2

    ; Turn off old selected section
    SectionGetFlags $1 $0
    IntOp $0 $0 & ${SECTION_OFF}
    SectionSetFlags $1 $0
    # !insertmacro UnselectSection $1

    ; Now remember the current selection
    Push $2
    StrCpy $2 $1

    SectionGetFlags ${sec31} $0
    IntOp $0 $0 & ${SF_SELECTED}
    IntCmp $0 ${SF_SELECTED} 0 +2 +2
        StrCpy $1 ${sec31}
    SectionGetFlags ${sec32} $0
    IntOp $0 $0 & ${SF_SELECTED}
    IntCmp $0 ${SF_SELECTED} 0 +2 +2
        StrCpy $1 ${sec32}
    SectionGetFlags ${sec33} $0
    IntOp $0 $0 & ${SF_SELECTED}
    IntCmp $0 ${SF_SELECTED} 0 +2 +2
        StrCpy $1 ${sec33}

    StrCmp $2 $1 0 +4 ; selection hasn't changed
        SectionGetFlags $1 $0
        IntOp $0 $0 | ${SF_SELECTED}
        SectionSetFlags $1 $0
        # !insertmacro SelectSection $1
    Pop $2
    Pop $0
FunctionEnd

Function createShortcuts
      RMDir /r "$SMPROGRAMS\${PROG_NAME}"
  CreateDirectory "$SMPROGRAMS\${PROG_NAME}"
  CreateShortCut "$SMPROGRAMS\${PROG_NAME}\Uninstall ${PROG_NAME}.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0

  SectionGetFlags ${sec2} $R0
  IntOp $R0 $R0 & ${SF_SELECTED}
  StrCmp $R0 ${SF_SELECTED} "" +5
  CreateShortCut "$SMPROGRAMS\${PROG_NAME}\${PROG_NAME} Readme.lnk" "$INSTDIR\doc\readme.txt" "" "$INSTDIR\doc\readme.txt" 0
  CreateShortCut "$SMPROGRAMS\${PROG_NAME}\${PROG_NAME} Readme (rus).lnk" "$INSTDIR\doc\readme.rus.txt" "" "$INSTDIR\doc\readme.rus.txt" 0
  CreateShortCut "$SMPROGRAMS\${PROG_NAME}\${PROG_NAME} Help.lnk" "$INSTDIR\doc\help.chm" "" "$INSTDIR\doc\help.chm" 0
  CreateShortCut "$SMPROGRAMS\${PROG_NAME}\${PROG_NAME} Help (rus).lnk" "$INSTDIR\doc\help_ru.chm" "" "$INSTDIR\doc\help_ru.chm" 0
FunctionEnd

Function IsSilent
  Push $0
  Push $CMDLINE
  Push "/S"
  Call StrStr
  Pop $0
  StrCpy $0 $0 3
  StrCmp $0 "/S" silent
  StrCmp $0 "/S " silent
    StrCpy $0 0
    Goto notsilent
  silent: StrCpy $0 1
  notsilent: Exch $0
FunctionEnd

Function StrStr
  Exch $R1 ; st=haystack,old$R1, $R1=needle
  Exch    ; st=old$R1,haystack
  Exch $R2 ; st=old$R1,old$R2, $R2=haystack
  Push $R3
  Push $R4
  Push $R5
  StrLen $R3 $R1
  StrCpy $R4 0
  ; $R1=needle
  ; $R2=haystack
  ; $R3=len(needle)
  ; $R4=cnt
  ; $R5=tmp
  loop:
    StrCpy $R5 $R2 $R3 $R4
    StrCmp $R5 $R1 done
    StrCmp $R5 "" done
    IntOp $R4 $R4 + 1
    Goto loop
  done:
  StrCpy $R1 $R2 "" $R4
  Pop $R5
  Pop $R4
  Pop $R3
  Pop $R2
  Exch $R1
FunctionEnd
