\ jobedit

REQUIRE Control     ~nn/lib/win/control.f
REQUIRE TabControl  ~nn/lib/win/controls/tab.f
REQUIRE ComboBox ~nn/lib/win/controls/combobox.f
REQUIRE RES ~nn/lib/res.f

-5 TO 1st-row

CLASS: JobEditDialog <SUPER FrameWindow
    var vFileName

25 VALUE header_height \    tab-
5 VALUE left_margin \    tab-
5 VALUE right_margin \    tab-
40 VALUE footer_height \    tab-

13 CONSTANT but_h   \  
37 CONSTANT but_w   \  


M: setGeometry
   GetPos         parGuiJobEditY set parGuiJobEditX set 
   GetWindowSize  parGuiJobEditH set parGuiJobEditW set
;

\ -------------------------- header -------------------------

USER tab1
: tab+ ( index -- )  this SWAP tab1 @ ->CLASS TabControl AddEl ;
  
TabControl OBJ tab
        :init a v 
            this tab1 !
            left_margin header_height pos
            tabstop
\            vStyle @ WS_TABSTOP OR vStyle !
;
Static OBJ st_name
    :init a v 0 1 5 1 ps 110 RES text ;
Edit OBJ ed_name
    :init a v  0 5 5 1 ps 
        this parJobName ctrl!
        tabstop ;

Static OBJ st_mode
    :init a v 0 12 5 1 ps 310 RES text ;
ComboBox OBJ cmb_mode
    :init a v  0 16 5 10 ps 
        this parWorkMode ctrl!
        tabstop ;
        
\ ---------------- main -----------------------------
Static OBJ st_src_path
    :init a v 0 tab+ 4 1 5 1 ps 340 RES text ;
    
ListBox OBJ lst_src_path
    :init a v 0 tab+ 4 5 15 4 ps tabstop this parSrcPath ctrl! ;

Button OBJ but_add_src
    :init a v 0 tab+ 4 21 2 1 ps tabstop 334 RES text ; 


Static OBJ st_dst_path
    :init a v 0 tab+ 8 1 5 1 ps 341 RES text ;
    
Edit OBJ ed_dst_path
    :init a v 0 tab+ 8 5 15 1 ps tabstop this parDstPath ctrl! ;

Button OBJ but_choose_src
    :init a v 0 tab+ 8 21 1 1 ps tabstop S" ..." text ; 

Static OBJ st_log_file
    :init a v 0 tab+ 10 1 5 1 ps 342 RES text ;
    
Edit OBJ ed_log_file
    :init a v 0 tab+ 10 5 15 1 ps tabstop this parLogFile ctrl! ;

Button OBJ but_choose_log_file
    :init a v 0 tab+ 10 21 1 1 ps tabstop S" ..." text ; 

\ ---------------- files -----------------------------

CheckBox OBJ cb_use_inc
    :init a  1 tab+ 4 1 10 1 ps 350 RES text tabstop this parUseIncludingMasks ctrl! ;
Edit OBJ ed_inc_masks
    :init a 1 tab+ 5 1 20 1 ps tabstop this parIncludingMasks ctrl! ;

CheckBox OBJ cb_use_exc
    :init a  1 tab+ 7 1 10 1 ps 351 RES text tabstop this parUseExcludingMasks ctrl! ;
Edit OBJ ed_exc_masks
    :init a 1 tab+ 8 1 20 1 ps tabstop this parExcludingMasks ctrl! ;

CheckBox OBJ cb_created_since
    :init a 1 tab+ 10 1 10 1 ps tabstop 352 RES text  this parCopyCreatedSince ctrl! ;
CheckBox OBJ cb_changed_since
    :init a 1 tab+ 11 1 10 1 ps tabstop 353 RES text  this parCopyChangedSince ctrl! ;
Edit OBJ ed_copy_date
    :init a 1 tab+ 11 11 5 1 ps tabstop this parCopyDate ctrl! ;

Static OBJ st_copy_date
    :init a 1 tab+ 11 17 5 1 ps 354 RES text ;

\ ---------------- options -----------------------------

CheckBox OBJ cb_with_subtree
    :init a  2 tab+ 4 1 10 1 ps 360 RES text tabstop this parSubTree ctrl! ;

CheckBox OBJ cb_copy_empty_dirs
    :init a  2 tab+ 5 1 10 1 ps 361 RES text tabstop this parCopyEmptyDirs ctrl! ;

CheckBox OBJ cb_copy_access_rights
    :init a  2 tab+ 6 1 10 1 ps 362 RES text tabstop this parCopyAccessRights ctrl! ;

CheckBox OBJ cb_verbose
    :init a  2 tab+ 4 11 10 1 ps 363 RES text tabstop this parVerbose ctrl! ;

CheckBox OBJ cb_quiet
    :init a  2 tab+ 5 11 10 1 ps 364 RES text tabstop this parQuiet ctrl! ;

CheckBox OBJ cb_ignore_errors
    :init a  2 tab+ 6 11 10 1 ps 365 RES text tabstop this parIgnoreErrors ctrl! ;

M: onOk 
   setGeometry 
   0 PostQuitMessage DROP
;

Button OBJ but_ok
    :init a v  but_w but_h size
            ['] onOk OnClick !
            330 RES text  tabstop  ;


M: onCancel 
   setGeometry 
   0 PostQuitMessage DROP
;

Button OBJ but_cancel
    :init a v  but_w but_h size
            331 RES text  ['] onCancel OnClick ! ;
            
M: onHelp  ;
Button OBJ but_help
    :init a v  but_w but_h size
            332 RES text  ['] onHelp OnClick ! ;


DESTR: free
    setGeometry
    free
    vFileName @ ?DUP IF FREE DROP THEN ;

: but_comm_y but_h 5 2 */ - ;
: but_comm_x ( w n-from-right -- x )  but_w right_margin + * - right_margin - ;

M: SetElementsPS { \ w h } 
\ tab-control
    GetWindowSize ( w h ) FromPixels TO h TO w
    w left_margin - right_margin - 3 -
    h header_height - footer_height - 
    tab SetSize
\ buttons
    w 1 but_comm_x h but_comm_y ToPixels but_ok SetPos
    w 2 but_comm_x h but_comm_y ToPixels but_cancel SetPos
    w 4 but_comm_x h but_comm_y ToPixels but_help SetPos
;

W: WM_SIZE
    SetElementsPS
;

CREATE (tab-select)  ' NOOP , ' NOOP , ' NOOP ,  ' NOOP ,  ' NOOP ,  ' NOOP ,  

M: TabSelect (tab-select) tab Current CELLS + @ EXECUTE  TRUE ;

M: BeforeTabSelect 0 ( 0 -  ,   ) 
    ( tab Current TAB-ADV = IF adv-parse is-adv @ ELSE 0 THEN ) ;

: CreateTab
    6 0 DO 303 I + RES I tab Insert LOOP
\    S" testttt" 4 tab Insert
    ['] TabSelect tab OnSelChange !
    ['] BeforeTabSelect tab OnSelChanging !
;

VM: Style WS_THICKFRAME ;
M: open-help ;
: processKeyDown
    wparam @
    CASE
    VK_F1  OF onHelp TRUE ENDOF
    VK_TAB OF
\                 ed_scr isActive
\                 IF isShift? IF cmb_action SetFocus ELSE ok_button SetFocus THEN ELSE
\                 ed_adv isActive
\                 IF isShift? IF tab SetFocus ELSE ok_button SetFocus THEN ELSE
\                 ed_cron_tim isActive
\                 IF isShift? IF rb_cron_tim SetFocus ELSE cb_log SetFocus THEN ELSE
\                 FALSE THEN THEN THEN
                FALSE
           ENDOF
        FALSE SWAP
    ENDCASE
;

M: Create ( parent -- )
\      WS_CAPTION  WS_SYSMENU OR WS_THICKFRAME OR WS_MINIMIZEBOX OR
\      WS_OVERLAPPEDWINDOW OR
\      WS_MAXIMIZEBOX OR  vStyle !
\    vStyle @ DS_MODALFRAME OR  vStyle !
\      WS_EX_CLIENTEDGE   vExStyle !

\ -5 TO 1st-row

    Create
    vFileName @ ?DUP IF ASCIIZ> S" %302 RES% : %1 esPICKS%" EVAL-SUBST ELSE 301 RES THEN  SetText
    
    parGuiJobEditX get parGuiJobEditY get SetPos
    parGuiJobEditW get parGuiJobEditH get FromPixels SetSize

    
    AutoCreate
    CreateTab
    SetElementsPS

    job-pars-to-form

    handle @ set-window-icons
;

M: SetFile S>ZALLOC vFileName ! ;

;CLASS

JobEditDialog POINTER jed

: RunJobEdit ( a u h -- )
    JobEditDialog NEW TO jed
    >R
    jed SetFile
    R> jed Create
    jed Show
    jed Run
    jed SELF DELETE
;

\  : RunJobNew ( h -- )
\      JobEditDialog NEW TO jed
\      jed Create
\      jed ShowModal
\      jed Run
\      jed SELF DELETE
\  ;
