REQUIRE FrameWindow ~nn/lib/win/framewindow.f
REQUIRE Control ~nn/lib/win/control.f
REQUIRE MENU ~nn/lib/win/menu.f
REQUIRE ToolBar ~nn/lib/win/controls/ToolBar.f
REQUIRE StatusBar ~nn/lib/win/controls/StatusBar.f
REQUIRE ListView ~nn/lib/win/controls/ListView.f
\ REQUIRE TreeView ~nn/lib/win/controls/TreeView.f
REQUIRE FOR-FILES ~nn/lib/for-files3.f
REQUIRE ImageList ~nn/lib/win/controls/imagelist.f
REQUIRE ONLYNAME ~nn/lib/filename.f

CLASS: MainFrame <SUPER FrameWindow
350 VALUE width
200 VALUE height
70 VALUE tree_width

ToolBar OBJ tb
    :init a v 
\        4 4 pos
        vStyle @ WS_BORDER OR vStyle !  ;

    TreeView OBJ tv_jobf
        :init a v ( 5 5 pos 63 ( 142> height 39 - size)
            tree_width height 39 - size
            tabstop
            TVS_HASLINES 
            TVS_LINESATROOT  OR
            WS_TABSTOP OR
            TVS_HASBUTTONS OR
            vStyle ! ;

\ ListBox OBJ lv_job
ListView OBJ lv_job
   :init a v  0 -1 pos 200 100 size tabstop
        LVS_EX_GRIDLINES LVS_EX_FULLROWSELECT OR v_ex_style ! ;

StatusBar OBJ sb    :init a v ;


VM: CreateMenu
    MENU
    
    \ file
    POPUP
      MENUSEPARATOR
      19 RES    MI_EXIT         MENUITEM
    10 RES END-POPUP

    \ job
    POPUP
      21 RES    MI_JOBNEW         MENUITEM
      22 RES    MI_JOBEDIT        MENUITEM
      23 RES    MI_JOBDEL         MENUITEM
      MENUSEPARATOR
      24 RES    MI_JOBRUN         MENUITEM
      25 RES    MI_JOBPAUSE       MENUITEM
      26 RES    MI_JOBSTOP        MENUITEM
    20 RES END-POPUP


    \ view
\      POPUP
\        31 RES  MI_LARGEICONS   MENUITEM
\        32 RES  MI_SMALLICONS   MENUITEM
\        33 RES  MI_LIST         MENUITEM
\        34 RES  MI_DETAILS      MENUITEM
\      30 RES END-POPUP

    \ help
    POPUP
      91 RES      MI_CONTENT      MENUITEM
      99 RES      MI_ABOUT        MENUITEM
    90 RES END-POPUP
    END-MENU
    DUP vMenu !
;

M: setGeometry
   GetPos         parGuiMainY set parGuiMainX set 
   GetWindowSize  parGuiMainH set parGuiMainW set
   0 lv_job GetColumnWidth parGuiMainCol1W set
   1 lv_job GetColumnWidth parGuiMainCol2W set
   2 lv_job GetColumnWidth parGuiMainCol3W set
   3 lv_job GetColumnWidth parGuiMainCol4W set
;

VM: OnExit
\    0 Z" exit" Z" exit" 0 MessageBoxA DROP
    setGeometry
    saveBackupINI
;

MM: MI_EXIT 
    OnExit
    0 PostQuitMessage DROP
;

MM: MI_LARGEICONS  lv_job IconStyle ; 
MM: MI_SMALLICONS  lv_job SmallIconStyle ;
MM: MI_LIST        lv_job ListStyle  ;
MM: MI_DETAILS     lv_job ReportStyle ;

var vRunState
var vJobStarted
: change_run_state
    vRunState @ 
    IF 
        S" icon_start" 
    ELSE 
        S" icon_pause" 
        MI_JOBSTOP  tb EnableButton
    THEN 
    MI_JOBRUN tb SetIcon
    vRunState @ 0= vRunState !
;

MM: MI_JOBRUN
    vJobStarted @
    IF
        
    ELSE
        vJobStarted ON
    THEN
    change_run_state
;

MM: MI_JOBSTOP
    vRunState 0!
    vJobStarted 0!
    S" icon_start" MI_JOBRUN tb SetIcon
    MI_JOBSTOP  tb DisableButton
;

M: SetStyle
    WS_CAPTION  WS_SYSMENU OR WS_THICKFRAME OR WS_MINIMIZEBOX OR
    WS_OVERLAPPEDWINDOW OR
    WS_MAXIMIZEBOX OR  vStyle !
    WS_EX_CLIENTEDGE   vExStyle !
\    WS_EX_WINDOWEDGE
;
W: WM_ERASEBKGND 0 ;

W: WM_SIZE { \ w h h_sb w_lc h_tb hclient w_tv -- }
    lparam @ LOWORD TO w 
    lparam @ HIWORD TO h

\ 1. toolbar
    tb GetWindowSize NIP 1- TO h_tb
    0 0 w h_tb tb MovePixels

\ 2. status bar
    sb GetWindowSize TO h_sb DROP
    h h_sb sb SetSizePixels
\    0 h h_sb - 2+ sb SetPos

    h h_sb - h_tb - TO hclient

\ 3. tv_cat - 
\    tv_cat GetWindowSize DROP TO w_lc 
\    0 h_tb w_lc hclient tv_cat MovePixels
    tv_jobf GetWindowSize DROP TO w_tv
    0 h_tb w_tv hclient tv_jobf MovePixels

\ 4. list_job    
\    w_lc h_tb lv_job SetPos
\    w w_lc - hclient lv_job SetSizePixels

    w_tv h_tb w hclient lv_job MovePixels
    
    LVSCW_AUTOSIZE_USEHEADER 4 lv_job SetColumnWidth
;

N: TTN_GETDISPINFOA 
    lparam @ CELL+ @ tb GetButtonTip \ 2DUP 0 sb SetText
    DROP lparam @ 3 CELLS + ! ;


var vFoldersList (    )
var vCurFolder
var vJobsList

CLASS: FolderObj
    var vPath
    var vTVid   \ TreeView id (handle)
    CONSTR: init ( a u id -- ) vTVid !  S>ZALLOC vPath !    ;
    DESTR: free vPath @ FREE DROP ;
;CLASS

CLASS: JobObj
    var vPath
    var vLVid
    CONSTR: init ( a u id -- ) vLVid !  S>ZALLOC vPath !    ;
    DESTR: free vPath @ FREE DROP ;
;CLASS

VARIABLE ParentFolder
: AddFoldersTree { a u parent \ save-parent buf -- }
\    parent . a u TYPE CR
    a u parent FolderObj NEW vFoldersList AddNode
    ParentFolder @ TO save-parent
    parent ParentFolder !
\    FOR-FILES
\    tv_jobf vLastItem @ AddFoldersTree
    ~RECURSIVE
    a u S" \*.*" S+ OVER TO buf
\    2DUP TYPE CR
    FOR-FILES
        IS-DIR?
        IF
            0 FOUND-FILENAME ParentFolder @ tv_jobf AddItem
            FOUND-FULLPATH tv_jobf vLastItem @ FolderObj NEW vFoldersList AddNode
            FOUND-FULLPATH tv_jobf vLastItem @ RECURSE
        THEN
    ;FOR-FILES
    save-parent ParentFolder !
    buf FREE DROP
;
var vNumLVLine

M: ShowJobs ( a u -- )
    [NONAME NodeValue DELETE NONAME] vJobsList DoList
     vJobsList FreeList
    S" %1 esPICKS%\*.%nnBackupExt%" EVAL-SUBST
    lv_job ClearAll
    vNumLVLine 0!
    vJobsList 0!
    FOR-FILES
        0 FOUND-FILENAME nnBackupExt NIP 1+ - vNumLVLine @ lv_job InsertItem
        FOUND-FULLPATH ( 2DUP TYPE SPACE)  lv_job vLastIndex @ ( DUP . CR) JobObj NEW vJobsList AddNode
        vNumLVLine 1+!
    ;FOR-FILES
;

M: TVonSelChange
    [NONAME
        NodeValue DUP ->CLASS FolderObj vTVid @ tv_jobf vSelectedItem @ =
        IF 
            ->CLASS FolderObj vPath @AZ 
            ShowJobs
            \ DROP 0 SWAP DUP 0 MessageBoxA DROP
        ELSE DROP THEN
    NONAME] vFoldersList DoList
    
;

M: JobEdit ( a u -- )
\      ShowMessage
    SP@ 2 CELLS + >R
    this RunJobEdit
\      SP@ .  
    R> 
\      DUP . CR
    SP!
;

M: LVOnDoubleClick
    SP@ S0 !
\      ." enter " DEPTH . CR
    vJobsList
    BEGIN @ ?DUP WHILE
        DUP NodeValue DUP ->CLASS JobObj vLVid @ lv_job vSelectedItem @ =
        IF
            ->CLASS JobObj vPath @AZ JobEdit
            DROP 
\              ." exit 1 " DEPTH . CR
            EXIT
        ELSE DROP THEN
    REPEAT
\      ." exit 2 " DEPTH . CR
;

M: Create
    SetStyle
    0 Create
    100 RES SetText

\    width height Center 
    parGuiMainX get parGuiMainY get SetPos
    parGuiMainW get parGuiMainH get FromPixels SetSize

    AutoCreate
  
    handle @ set-window-icons
    
    lv_job ReportStyle

    110 RES parGuiMainCol1W get 0 lv_job InsertColumn
    111 RES parGuiMainCol2W get 1 lv_job InsertColumn
    114 RES parGuiMainCol3W get 2 lv_job InsertColumn
    112 RES parGuiMainCol4W get 3 lv_job InsertColumn
    113 RES LVSCW_AUTOSIZE_USEHEADER 4 lv_job InsertColumn

\    LVSCW_AUTOSIZE_USEHEADER 4 lv_job SetColumnWidth
    
    16 S" jobs16" LoadImageListBMP lv_job SetILSmall
    32 S" jobs32" LoadImageListBMP lv_job SetILNormal

\      HINST_COMMCTRL IDB_STD_SMALL_COLOR TB_LOADIMAGES tb SendMessage DROP
\      HINST_COMMCTRL IDB_VIEW_SMALL_COLOR TB_LOADIMAGES tb SendMessage DROP
\      tbBUTTONS 7 TB_ADDBUTTONSA tb SendMessage DROP

\    imgl Create

    S" icon_jobnew" MI_JOBNEW 201 RES tb AddButton
    S" icon_jobedit" MI_JOBEDIT 202 RES tb AddButton
    S" icon_jobcopy" MI_JOBCOPY 203 RES tb AddButton
    S" icon_jobdel" MI_JOBDEL 204 RES tb AddButton
    tb AddSeparator
\    S" icon_folder" MI_JOBNEW S" folder" tb AddButton
    S" icon_foldernew" MI_FOLDERNEW 208 RES tb AddButton
    S" icon_folderdel" MI_FOLDERDEL 209 RES tb AddButton    
    tb AddSeparator
    S" icon_start" MI_JOBRUN 205 RES tb AddButton
    S" icon_stop" MI_JOBSTOP 207 RES tb AddButton
    MI_JOBSTOP  tb DisableButton
    tb AddSeparator
    S" icon_exit" MI_EXIT 200 RES tb AddButton

\ data ---------------------
\      0 S" ver" 0 lv_job InsertItem
\      1 S" sync" 1 lv_job InsertItem
\      2 S" sync2" 2 lv_job InsertItem
\      3 S" dump" 3 lv_job InsertItem
\      4 S" verz" 4 lv_job InsertItem
\      5 S" copy" 5 lv_job InsertItem

    S" icon_folder2" tv_jobf AddIcon
    S" icon_folder2o" tv_jobf AddIcon
    
    [NONAME
        NodeValue ASCIIZ>
        2DUP 0 ROT ROT ONLYNAME 0 tv_jobf AddItem
        tv_jobf vLastItem @ AddFoldersTree
    NONAME] parGuiJobFolder get DoList
    
    ['] TVonSelChange tv_jobf OnSelChange !
    tv_jobf Root tv_jobf SelectItem
    
    ['] LVOnDoubleClick lv_job OnDoubleClick !
;

;CLASS


MainFrame POINTER mw

: MAIN
\    AT-PROCESS-STARTING
\    AT-THREAD-STARTING

    MainFrame NEW TO mw
    mw Create
    mw Show
\    mw vNoNotify 0!
    mw Run
    mw SELF DELETE
    BYE
;

\ MAIN