REQUIRE Control     ~nn/lib/win/control.f
REQUIRE TreeView ~nn/lib/win/controls/treeview.f
REQUIRE ComboBox ~nn/lib/win/controls/combobox.f
REQUIRE RES ~nn/lib/res.f
REQUIRE PLACE lib\ext\string.f
REQUIRE JMP ~nn/lib/jmp.f
REQUIRE get-string ~nn/lib/getstr.f
REQUIRE StartApp ~nn/lib/process.f
REQUIRE FOR-FILES ~nn/lib/for-files3.f
REQUIRE <EOF> ~nn/lib/eof.f
REQUIRE ICOMPARE agents/pop3rules/wcmatch.f
REQUIRE CASE lib/ext/case.f
REQUIRE MAKE-BAK ~nn/lib/bak.f
REQUIRE EVAL-SUBST ~nn/lib/subst1.f
REQUIRE ?BYE-IF-EXIST ~nn/lib/win/windows/secondcopy.f

0 VALUE LANGUAGE

CLASS: OptionsDialog <SUPER FrameWindow

( 225) 240 VALUE width
( 181) 250 VALUE height
13 CONSTANT but_h
37 CONSTANT but_w
: but_col ( # -- col ) but_w 5 + * width 1st-col + SWAP - 5 - ;
: but_row height but_h 2* - 5 - ;
: button  WITH Control but_col but_row pos but_w but_h size tabstop ENDWITH ;


VARIABLE fwc-list   \ Frame window controls list
VARIABLE cur-frame

: sw ( # -- )
    2 CELLS ALLOCATE THROW >R
    this R@ !
    R@ CELL+ !
    R> fwc-list AddNode ;

: show-frame
    NodeValue >R
    R@ CELL+ @ cur-frame @ =
    IF R@ @ => Show THEN
    RDROP
;

: hide-frame
    NodeValue >R
    R@ CELL+ @ cur-frame @ =
    IF R@ @ => Hide THEN
    RDROP
;


M: FrameShow ( # -- ) cur-frame ! ['] show-frame fwc-list DoList ;
M: FrameHide ( # -- ) cur-frame ! ['] hide-frame fwc-list DoList ;

\    Static OBJ st_crontab
\        :init a v 0 1 4 1 ps  451 RES text ;
\    Edit OBJ ed_crontab
\        :init a v 0 5 5 1 ps tabstop ;

    TreeView OBJ tree_opts
        :init a v 5 5 pos 63 ( 142) height 39 - size  tabstop
            TVS_HASLINES TVS_LINESATROOT  OR
            WS_TABSTOP OR
\            TVS_HASBUTTONS OR
            vStyle ! ;

    GroupBox OBJ grp1
        :init a v 70 2 pos width 80 - ( 145) height 36 - size 700 RES text ;

: c1 8 ;
: w1 6 ;
: c2 13 ;
: w2 9 ;
    Static OBJ st_crontabl
        :init 0 sw a v 0 8 10 1 ps  453 RES text ;

    ListBox OBJ lb_crontabl
        :init 0 sw a v 1 8 9 4 ps  tabstop ;

VARIABLE <rw>
: rw <rw> @ POSTPONE LITERAL ; IMMEDIATE
: rw++ <rw> 1+! ;
: rw+ <rw> @ POSTPONE LITERAL rw++ ; IMMEDIATE
: rw! <rw> ! ;

    4 rw!
    Static OBJ st_log
        :init 0 sw a v rw c1 w1 1 ps 455 RES text ;
    Edit OBJ ed_log
        :init 0 sw a v rw+ c2 w2 1 ps tabstop ;
    Static OBJ st_log_time
        :init 0 sw a v rw c1 w1 1 ps 456 RES text ;
    Edit OBJ ed_log_time
        :init 0 sw a v rw+ c2 w2 1 ps tabstop ;
    Static OBJ st_lang
        :init 0 sw a v rw 8 9 1 ps 460 RES text ;
    ComboBox OBJ cmb_lang
        :init 0 sw a v rw+ 18 4 4 ps tabstop ;


\ ---------------------------- Interface ----------------------------

    CheckBox OBJ cb_systray
        :init 1 sw a 0 8 6 1 ps 723 RES text tabstop ;

    CheckBox OBJ cb_adminonly
        :init 1 sw a 0 15 7 1 ps 750 RES text tabstop  ;

    GroupBox OBJ grp_menu
        :init 1 sw a 80 20 pos 100 58 size 724 RES text  ;

    CheckBox OBJ cb_options
        :init 1 sw a 2 9 8 1 ps 725 RES text tabstop ;

    CheckBox OBJ cb_exit
        :init 1 sw a 3 9 8 1 ps 726 RES text tabstop ;

    CheckBox OBJ cb_console
        :init 1 sw a 4 9 8 1 ps 727 RES text tabstop ;

    CheckBox OBJ cb_reload
        :init 1 sw a 5 9 8 1 ps 23 RES text tabstop  ;


    CheckBox OBJ cb_start_console
        :init 1 sw a 7 8 10 1 ps 728 RES text tabstop  ;


    Static OBJ st_tray_db
        :init 1 sw a 9 8 9 1 ps  482 RES text ;
    ComboBoxEdit OBJ cmb_tray_db
        :init 1 sw a  9 17 5 8 ps tabstop 
        ;
        
    Static OBJ st_tray_rb
        :init 1 sw a 11 8 9 1 ps  483 RES text ;
    ComboBoxEdit OBJ cmb_tray_rb
        :init 1 sw a  11 17 5 8 ps tabstop
        ;
        
\ ----------------------------------------------------------------------

    M: onOk BYE ;
    Button OBJ but_ok
        :init a v 2 button 200 RES text ['] onOk OnClick ! ;
    M: onCancel BYE ;
    Button OBJ but_cancel
        :init a v 1 button 201 RES text ['] onCancel OnClick ! ;


    M: onTreeChange { \ iprev icur -- }
\        0 S" ok" DROP DUP 0 MessageBoxA DROP
        lparam @ 13 CELLS + @ TO iprev
        lparam @ 23 CELLS + @ TO icur
        iprev icur <>
        IF
            lparam @ 15 CELLS + @  \ hItem
            tree_opts GetItemText \ 2DUP TYPE CR
            grp1 SetText
            iprev FrameHide
            icur FrameShow
        THEN
    ;

: open-help ;
: processKeyDown
    wparam @
    CASE
    VK_F1  OF open-help TRUE ENDOF
        FALSE SWAP
    ENDCASE
;
0 VALUE CUR-LANG
0 VALUE num
: fill-langs 
    0 TO CUR-LANG
    0 TO num
    S" res/*.txt" FOR-FILES
        FOUND-FILENAME 4 - 2DUP LANGUAGE ?DUP 
        IF ASCIIZ> ICOMPARE 0= 
           IF num TO CUR-LANG THEN
        ELSE 2DROP THEN
        2DUP + 0 SWAP C!
        cmb_lang Add
        num 1+ TO num
    ;FOR-FILES
    CUR-LANG cmb_lang Current!
;

M: Create
\    WS_EX_CONTEXTHELP vExStyle @ OR vExStyle !
    0 TO 1st-row 0 TO 1st-col
    0 Create
    AutoCreate
    0 FrameShow
    450 RES 2DUP ?BYE-IF-EXIST SetText
    width height Center

    fill-langs
    
    4 0 DO I 700 + RES 0 tree_opts AddTextItem LOOP

    tree_opts ExpandAll
    
    ['] onTreeChange tree_opts OnSelChange !

    ['] processKeyDown onKeyDown !
;

;CLASS

OptionsDialog POINTER opt
: Options
    OptionsDialog NEW TO opt
    opt Create
    opt Show
    opt Run
    opt SELF DELETE
    BYE
;
